local MakePlayerCharacter = require "prefabs/player_common"


local assets = {
Asset("SCRIPT", "scripts/prefabs/player_common.lua"),
}
local prefabs = {}

-- 初始物品
local start_inv = {
"pipi_np","pipi_ycb","pipi_glass"
}


local function applyupgrades(inst)

	local exp =inst.components.pipi_milk.exp
	inst.components.hunger.max =  90 +  exp*0.1
	inst.components.health.maxhealth =  90 +  exp*0.1
	inst.components.sanity.max =  90 +  exp*0.1
	inst.components.combat.damagemultiplier = 1 + exp*0.001
	
	
	inst.components.locomotor.walkspeed = 3 + exp*0.01
	inst.components.locomotor.runspeed = 4 + exp*0.01
	
	
	inst.Transform:SetScale(1+exp*0.001,1+exp*0.001,1+0.001*exp)
	
	inst.components.health:SetAbsorptionAmount(math.min(exp*0.001,1))

	
end
local function shuxing(inst)
	
	if inst.touxian == nil then
		inst.touxian = SpawnPrefab("milkexp")
		inst.touxian.entity:SetParent(inst.entity)	
	end
	 local YanSe = 1 
	  local sstr =  "当前存奶量："..inst.components.pipi_milk.exp
		inst.touxian:Stext(sstr,3.2,18,YanSe,true) 
	
	 if inst.components.hunger.current < 20 and  inst.components.pipi_milk.exp >=1 then
	
	  inst.components.hunger:DoDelta(20)
	   inst.components.pipi_milk.exp = inst.components.pipi_milk.exp - 1
	
	end
	
	if inst.components.health.currenthealth < 20 and  inst.components.pipi_milk.exp >=1  and not inst.components.health:IsDead() then
	
	  inst.components.health:DoDelta(20)
	   inst.components.pipi_milk.exp = inst.components.pipi_milk.exp - 1
	
	end
	
	
end


-- 当人物复活的时候
local function onbecamehuman(inst)
	
	inst.components.locomotor:SetExternalSpeedMultiplier(inst, "pipi_speed_mod", 1)
end
--当人物死亡的时候
local function onbecameghost(inst)
	
	inst.components.locomotor:RemoveExternalSpeedMultiplier(inst, "pipi_speed_mod")
end

local function onload(inst)
	inst:ListenForEvent("ms_respawnedfromghost", onbecamehuman)
	inst:ListenForEvent("ms_becameghost", onbecameghost)
	applyupgrades(inst)
	shuxing(inst)
	if inst:HasTag("playerghost") then
		onbecameghost(inst)
		
	else
		onbecamehuman(inst)
	end
end

local common_postinit = function (inst)
	-- Minimap icon
	inst.MiniMapEntity:SetIcon( "pipi.tex" )
	inst:AddTag("pipi_builder")
	inst.currentmilk = net_int(inst.GUID,"currentmilk")
	inst:AddTag("bookbuilder")
    inst:AddTag("reader")

end

local function oneat(inst, food)
	
	if food and food.components.edible and food.prefab == "goatmilk" or food.prefab == "icecream" or food.prefab == "taffy" then
		--inst.components.talker:Say("喝奶奶！",1)
		inst.components.pipi_milk.exp = inst.components.pipi_milk.exp + 1
		inst:DoTaskInTime(0.5, function ()
			local fx = SpawnPrefab("milkup")
			fx.Transform:SetPosition(inst.Transform:GetWorldPosition())			
		end)
		
	end
end

local function trinket(inst)

	if  not inst.components.health:IsDead()  then
		local trinketnum = "trinket_"..math.floor(math.random(1,46))
	 	SpawnPrefab(trinketnum).Transform:SetPosition(inst.Transform:GetWorldPosition())		
	end
end




local master_postinit = function (inst)
	-- 人物音效
	inst.soundsname = "willow"
	 inst:AddComponent("reader")
	inst:AddComponent("pipi_milk")
	
	inst:DoPeriodicTask(1,function()
    shuxing(inst)
    applyupgrades(inst)
end)

	-- 饥饿速度
	inst.components.hunger.hungerrate = 1 * TUNING.WILSON_HUNGER_RATE
	
	inst.components.eater:SetOnEatFn(oneat)
	inst:WatchWorldState("cycles", function (inst) trinket(inst) end)
	trinket(inst)
	inst.OnLoad = onload
	inst.OnNewSpawn = onload
	
end

return MakePlayerCharacter("pipi", prefabs, assets, common_postinit, master_postinit, start_inv)
