local assets=
{
Asset("ANIM", "anim/pipi_glass.zip"),
Asset("IMAGE", "images/inventoryimages/pipi_glass.tex"),
Asset("ATLAS", "images/inventoryimages/pipi_glass.xml"),
}



local function droppedfn( owner, inst )
    --inst.components.inventoryitem:OnDropped()
    local item = inst.components.equippable:IsEquipped() and owner.components.inventory:Unequip(inst.components.equippable.equipslot) or inst
    owner.components.inventory:DropItem(item)
	owner.components.talker:Say("这是皮皮的眼镜")
end
local function onpickup( inst, owner )
  if not owner:HasTag("pipi_builder") then
	owner:DoTaskInTime(0.1,droppedfn,inst)		
end
end

local function onequiphat(inst, owner)
		if not owner:HasTag("pipi_builder") then
	owner:DoTaskInTime(0.1,droppedfn,inst)		
     end
	owner.AnimState:OverrideSymbol("swap_hat", "pipi_glass", "swap_hat")
	owner.AnimState:Show("HAT")
	owner.AnimState:Show("HAT_HAIR")
	owner.AnimState:Hide("HAIR_NOHAT")
	owner.AnimState:Hide("HAIR")
	if owner:HasTag("player") then
		owner.AnimState:Hide("HEAD")
		owner.AnimState:Show("HEAD_HAT")
	end
	if inst.fire == nil then
			inst.fire = SpawnPrefab("nightstickfire")
			inst.fire.entity:AddFollower()
			inst.fire.Follower:FollowSymbol(owner.GUID, "swap_object", 0, -110, 0)
		end
	
end


local function onunequiphat(inst, owner)
	owner.AnimState:Hide("HAT")
	owner.AnimState:Hide("HAT_HAIR")
	owner.AnimState:Show("HAIR_NOHAT")
	owner.AnimState:Show("HAIR")
	if owner:HasTag("player") then
		owner.AnimState:Show("HEAD")
		owner.AnimState:Hide("HEAD_HAT")
	end
	
		if inst.fire ~= nil then
		inst.fire:Remove()
		inst.fire = nil
	end
	
end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	inst.entity:AddNetwork()
	MakeInventoryPhysics(inst)
	
	anim:SetBank("pipi_glass")
	anim:SetBuild("pipi_glass")
	anim:PlayAnimation("anim")
	
	inst:AddComponent("tradable")
	inst:AddTag("hat")
	
	inst.entity:SetPristine()
	
	if not TheWorld.ismastersim then
		return inst
	end
	
	
	inst:AddComponent("inspectable")
	inst.components.inspectable.description = "皮皮萌萌小眼镜"
	
	
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/pipi_glass.xml"
	inst.components.inventoryitem.imagename = "pipi_glass"
	inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/bushhat"
	inst.components.inventoryitem:SetOnPickupFn(onpickup)
	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
	inst.components.equippable.dapperness = TUNING.DAPPERNESS_LARGE
	inst.components.equippable:SetOnEquip( onequiphat )
	inst.components.equippable:SetOnUnequip( onunequiphat )
	inst.components.equippable.walkspeedmult = 1.2
	
	
	
	return inst
end

return Prefab( "common/inventory/pipi_glass", fn, assets, prefabs)