local assets=
{
Asset("ANIM", "anim/pipi_np.zip"),
Asset("ANIM", "anim/swap_pipi_np.zip"),
Asset("ANIM", "anim/swap_pipi_np2.zip"),
Asset("ATLAS", "images/inventoryimages/pipi_np.xml"),
}

local prefabs = {
"milkup",
"npfx",
}



local function droppedfn( owner, inst )
    --inst.components.inventoryitem:OnDropped()
    local item = inst.components.equippable:IsEquipped() and owner.components.inventory:Unequip(inst.components.equippable.equipslot) or inst
    owner.components.inventory:DropItem(item)
	owner.components.talker:Say("这是皮皮的奶瓶")
end
local function onpickup( inst, owner )
  if not owner:HasTag("pipi_builder") then
	owner:DoTaskInTime(0.1,droppedfn,inst)		
end
end


local function onequip(inst, owner)
		if not owner:HasTag("pipi_builder") then
	owner:DoTaskInTime(0.1,droppedfn,inst)		
     end
	owner.AnimState:OverrideSymbol("swap_object", "swap_pipi_np", "swap_pipi_np")
	owner.AnimState:Show("ARM_carry")
	owner.AnimState:Hide("ARM_normal")
	
end

local function onunequip(inst, owner)
	owner.AnimState:Hide("ARM_carry")
	owner.AnimState:Show("ARM_normal")

	
end


local function onattack(inst, attacker, target, owner)
	--attacker.AnimState:OverrideSymbol("swap_object", "swap_pipi_np2", "swap_pipi_np2")
	if target ~= nil  and  target.components.health.maxhealth>= 1000  and target.components.health:IsDead() then
	attacker.components.pipi_milk.exp = attacker.components.pipi_milk.exp + 1	
	inst:DoTaskInTime(1, function ()	
	local fx = SpawnPrefab("milkup")
	fx.Transform:SetPosition(attacker.Transform:GetWorldPosition())		
		end)
	end
	--attacker:ListenForEvent("locomote", onequip(inst,attacker))
	
	
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	MakeInventoryPhysics(inst)
	inst.entity:AddNetwork()
	inst.entity:SetPristine()
	
	inst.AnimState:SetBank("pipi_np")
	inst.AnimState:SetBuild("pipi_np")
	inst.AnimState:PlayAnimation("idle")
	if not TheWorld.ismastersim then
		return inst
	end

	inst:AddTag("blowdart")
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/pipi_np.xml"
	inst.components.inventoryitem:SetOnPickupFn(onpickup)
	inst:AddComponent("equippable")
	inst.components.equippable:SetOnEquip( onequip )
	inst.components.equippable:SetOnUnequip( onunequip )
	inst.components.equippable.walkspeedmult = 1.2
	inst:AddComponent("weapon")
	inst.components.weapon:SetDamage(50)
	inst.components.weapon:SetOnAttack(onattack)
	inst.components.weapon:SetRange(3)
	inst.components.weapon:SetProjectile("npfx")

	
	inst:AddComponent("inspectable")
	inst.components.inspectable.description = "皮皮的奶瓶!"
	

	MakeHauntableLaunch(inst)
	return inst
end


return Prefab("common/inventory/pipi_np", fn, assets, prefabs)
