local assets=
{
	Asset("ANIM", "anim/pipi_ycb.zip"),
	Asset("IMAGE", "images/inventoryimages/pipi_ycb.tex"),
	Asset("ATLAS", "images/inventoryimages/pipi_ycb.xml"),
}

local function onusehat(inst)
    local owner = inst.components.inventoryitem:GetGrandOwner()
    if owner then
        owner.sg:GoToState("hide")
    end
end

local function stopusinghat(inst, data)
        local hat = inst.components.inventory and inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
        if hat and not (data.statename == "hide_idle" or data.statename == "hide") then
            hat.components.useableitem:StopUsingItem()
        end
end

local function ShouldAcceptItem(inst, item,giver)
	if giver.components.inventory and giver.components.inventory:Has("goldnugget", 1) then
		if item.prefab == "goldnugget" then
			return true
		end
	end
	return false
end

local function OnGetItemFromPlayer(inst, giver, item)
	if item.prefab == "goldnugget" then
    giver.components.inventory:ConsumeByName("goldnugget", 4)
	end
	if giver.components.talker then
		giver.components.talker:Say("(*^▽^*)收果果(*^▽^*) ", 4, false) 
	end
    SpawnPrefab("book_fx").Transform:SetPosition(giver.Transform:GetWorldPosition())
	local pos = Vector3(inst.Transform:GetWorldPosition())
	local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 20)
		for k,v in pairs(ents) do
			if v.components.pickable and v.prefab ~= "flower" then
				v.components.pickable:Pick(giver)
			end
			if v.components.crop then
				v.components.crop:Harvest(giver)
			end
		end
end



local function droppedfn( owner, inst )
    --inst.components.inventoryitem:OnDropped()
    local item = inst.components.equippable:IsEquipped() and owner.components.inventory:Unequip(inst.components.equippable.equipslot) or inst
    owner.components.inventory:DropItem(item)
	owner.components.talker:Say("这是皮皮的洋葱辫")
end
local function onpickup( inst, owner )
  if not owner:HasTag("pipi_builder") then
	owner:DoTaskInTime(0.1,droppedfn,inst)		
end
end



local function onequiphat(inst, owner)
	if not owner:HasTag("pipi_builder") then
	owner:DoTaskInTime(0.1,droppedfn,inst)		
     end
    owner.AnimState:OverrideSymbol("swap_hat", "pipi_ycb", "swap_hat")
    owner.AnimState:Show("HAT")
    owner.AnimState:Show("HAT_HAIR")
    owner.AnimState:Hide("HAIR_NOHAT")
    owner.AnimState:Hide("HAIR")
	 if owner:HasTag("player") then
            owner.AnimState:Hide("HEAD")
            owner.AnimState:Show("HEAD_HAT")
        end
        
	inst.damagefn = function(attacked, data)
	SpawnPrefab("collapse_big").Transform:SetPosition(owner.Transform:GetWorldPosition())
	if data and data.attacker and data.attacker.components.health and data.attacker.components.combat and not data.attacker.components.health:IsDead() then
		data.attacker.components.combat:GetAttacked(inst, 34)
	end 
end
	inst:ListenForEvent("attacked", inst.damagefn, owner)
    inst:ListenForEvent("newstate", stopusinghat, owner) 
end

local function onunequiphat(inst, owner)
    owner.AnimState:Hide("HAT")
    owner.AnimState:Hide("HAT_HAIR")
    owner.AnimState:Show("HAIR_NOHAT")
    owner.AnimState:Show("HAIR")
        if owner:HasTag("player") then
            owner.AnimState:Show("HEAD")
            owner.AnimState:Hide("HEAD_HAT")
        end
	
	owner.components.health.absorb = 0
	inst:RemoveEventCallback("attacked", inst.damagefn, owner)
    inst:RemoveEventCallback("newstate", stopusinghat, owner)
end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()
	inst.entity:AddNetwork()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("bushhat")
    anim:SetBuild("pipi_ycb")
    anim:PlayAnimation("anim")
    
    inst:AddTag("sharp")
	inst:AddTag("hat")
	inst:AddTag("hide")
	
    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
    
	inst:AddComponent("waterproofer")
    inst.components.waterproofer:SetEffectiveness(TUNING.WATERPROOFNESS_LARGE)
	
	inst:AddComponent("tradable")
	
	inst:AddComponent("useableitem")
    inst.components.useableitem:SetOnUseFn(onusehat)
	
    inst:AddComponent("inspectable")
	inst.components.inspectable.description = "使用【躲猫猫】和【收果果】"
		
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/pipi_ycb.xml"
	inst.components.inventoryitem.imagename = "pipi_ycb"
	inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/bushhat"
    	inst.components.inventoryitem:SetOnPickupFn(onpickup)
    inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
	inst.components.equippable:SetOnEquip( onequiphat )
    inst.components.equippable:SetOnUnequip( onunequiphat )
	 inst:AddComponent("armor")
    inst.components.armor:InitCondition(TUNING.ARMOR_FOOTBALLHAT, TUNING.ARMOR_FOOTBALLHAT_ABSORPTION)
	inst:AddComponent("trader")
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader:SetAcceptTest(ShouldAcceptItem)
	

	
    return inst
end

return Prefab( "common/inventory/pipi_ycb", fn, assets, prefabs) 